default:
    image: ubuntu:devel

Build examples:
    stage: build
    script:
        - apt update
        - apt install --yes curl
        # Note: don't switch off warnings production! It's just to let my examples through
        - readonly FLAGS="$(curl -L turpin.cloud/flags_deprecated) -Wno-deprecated-declarations -Wno-float-conversion -Wno-unused-result -Og -lgtest -lgtest_main"
        - echo $FLAGS > flags.txt
        - apt install --yes libgtest-dev build-essential
        - c++ test.cxx -o test.o $FLAGS -L/usr/lib/ |& tee compiler_output.txt

    artifacts:
        paths: [test.o, compiler_output.txt, flags.txt]

Google Test:
    stage: test
    script:
        - ./test.o |& tee test_out.txt

    artifacts:
        paths: [test_out.txt, compiler_output.txt, flags.txt]

Doxygen:
    stage: deploy
    script:
        - apt update
        - apt install --yes doxygen graphviz
        - doxygen

    artifacts:
        paths: [html/, test_out.txt, compiler_output.txt, flags.txt]

pages:
    stage: deploy
    needs: ["Doxygen"]
    script:
        - apt update
        - apt install --yes pandoc

        # Append source and test results to readme
        - echo -e '```cpp' "\n$(cat test.cxx)\n" '```' >> README.md
        - echo "## Compiler flags" >> README.md
        - echo -e "$(cat flags.txt)\n" >> README.md
        - echo "## Compiler output" >> README.md
        - echo -e '```bash' "\n$(cat compiler_output.txt)\n" '```' >> README.md
        - echo "## Test output" >> README.md
        - echo -e '```bash' "\n$(cat test_out.txt)\n" '```' >> README.md
        - echo "## CI info" >> README.md
        - echo -e '```bash' "\n$(head -4 /etc/os-release)\n" '```' >> README.md

        # Generate HTML from markdown
        - mkdir public/
        - pandoc README.md --standalone --output public/index.html

    artifacts:
        paths: [public/]

